Index: config/locales/lt.yml
===================================================================
--- config/locales/lt.yml	(wersja 3378)
+++ config/locales/lt.yml	(kopia robocza)
@@ -954,3 +954,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/ro.yml
===================================================================
--- config/locales/ro.yml	(wersja 3378)
+++ config/locales/ro.yml	(kopia robocza)
@@ -883,3 +883,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/zh.yml
===================================================================
--- config/locales/zh.yml	(wersja 3378)
+++ config/locales/zh.yml	(kopia robocza)
@@ -908,3 +908,5 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
+ 
\ No newline at end of file
Index: config/locales/pt.yml
===================================================================
--- config/locales/pt.yml	(wersja 3378)
+++ config/locales/pt.yml	(kopia robocza)
@@ -898,3 +898,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/ca.yml
===================================================================
--- config/locales/ca.yml	(wersja 3378)
+++ config/locales/ca.yml	(kopia robocza)
@@ -883,3 +883,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/pt-BR.yml
===================================================================
--- config/locales/pt-BR.yml	(wersja 3378)
+++ config/locales/pt-BR.yml	(kopia robocza)
@@ -914,3 +914,4 @@
   label_change_log: Registro de alterações
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/tr.yml
===================================================================
--- config/locales/tr.yml	(wersja 3378)
+++ config/locales/tr.yml	(kopia robocza)
@@ -913,3 +913,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/ru.yml
===================================================================
--- config/locales/ru.yml	(wersja 3378)
+++ config/locales/ru.yml	(kopia robocza)
@@ -994,3 +994,4 @@
   label_board_locked: Заблокирована
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/id.yml
===================================================================
--- config/locales/id.yml	(wersja 3378)
+++ config/locales/id.yml	(kopia robocza)
@@ -898,3 +898,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/el.yml
===================================================================
--- config/locales/el.yml	(wersja 3378)
+++ config/locales/el.yml	(kopia robocza)
@@ -886,3 +886,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/en.yml
===================================================================
--- config/locales/en.yml	(wersja 3378)
+++ config/locales/en.yml	(kopia robocza)
@@ -336,6 +336,7 @@
   permission_edit_project: Edit project
   permission_select_project_modules: Select project modules
   permission_manage_members: Manage members
+  permission_manage_project_activities: Manage project activities
   permission_manage_versions: Manage versions
   permission_manage_categories: Manage issue categories
   permission_view_issues: View Issues
@@ -884,3 +885,4 @@
   enumeration_doc_categories: Document categories
   enumeration_activities: Activities (time tracking)
   enumeration_system_activity: System Activity
+
Index: config/locales/gl.yml
===================================================================
--- config/locales/gl.yml	(wersja 3378)
+++ config/locales/gl.yml	(kopia robocza)
@@ -906,3 +906,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/cs.yml
===================================================================
--- config/locales/cs.yml	(wersja 3378)
+++ config/locales/cs.yml	(kopia robocza)
@@ -886,3 +886,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/es.yml
===================================================================
--- config/locales/es.yml	(wersja 3378)
+++ config/locales/es.yml	(kopia robocza)
@@ -930,3 +930,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/zh-TW.yml
===================================================================
--- config/locales/zh-TW.yml	(wersja 3378)
+++ config/locales/zh-TW.yml	(kopia robocza)
@@ -977,3 +977,4 @@
   enumeration_system_activity: 系統活動
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/ko.yml
===================================================================
--- config/locales/ko.yml	(wersja 3378)
+++ config/locales/ko.yml	(kopia robocza)
@@ -946,3 +946,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/eu.yml
===================================================================
--- config/locales/eu.yml	(wersja 3378)
+++ config/locales/eu.yml	(kopia robocza)
@@ -888,5 +888,6 @@
   enumeration_system_activity: Sistemako Jarduera
   label_board_sticky: Sticky
   label_board_locked: Locked
-  permission_export_wiki_pages: Export wiki pages
-  setting_cache_formatted_text: Cache formatted text
+  permission_export_wiki_pages: Export wiki pages
+  setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/it.yml
===================================================================
--- config/locales/it.yml	(wersja 3378)
+++ config/locales/it.yml	(kopia robocza)
@@ -893,3 +893,5 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
+ 
\ No newline at end of file
Index: config/locales/sk.yml
===================================================================
--- config/locales/sk.yml	(wersja 3378)
+++ config/locales/sk.yml	(kopia robocza)
@@ -885,3 +885,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/sl.yml
===================================================================
--- config/locales/sl.yml	(wersja 3378)
+++ config/locales/sl.yml	(kopia robocza)
@@ -882,3 +882,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/uk.yml
===================================================================
--- config/locales/uk.yml	(wersja 3378)
+++ config/locales/uk.yml	(kopia robocza)
@@ -882,3 +882,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/sr.yml
===================================================================
--- config/locales/sr.yml	(wersja 3378)
+++ config/locales/sr.yml	(kopia robocza)
@@ -901,3 +901,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/da.yml
===================================================================
--- config/locales/da.yml	(wersja 3378)
+++ config/locales/da.yml	(kopia robocza)
@@ -906,3 +906,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/sv.yml
===================================================================
--- config/locales/sv.yml	(wersja 3378)
+++ config/locales/sv.yml	(kopia robocza)
@@ -935,3 +935,4 @@
   enumeration_system_activity: Systemaktivitet
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/bg.yml
===================================================================
--- config/locales/bg.yml	(wersja 3378)
+++ config/locales/bg.yml	(kopia robocza)
@@ -880,3 +880,5 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
+  
\ No newline at end of file
Index: config/locales/de.yml
===================================================================
--- config/locales/de.yml	(wersja 3378)
+++ config/locales/de.yml	(kopia robocza)
@@ -906,3 +906,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/ja.yml
===================================================================
--- config/locales/ja.yml	(wersja 3378)
+++ config/locales/ja.yml	(kopia robocza)
@@ -915,3 +915,4 @@
   enumeration_system_activity: システム作業分類
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/he.yml
===================================================================
--- config/locales/he.yml	(wersja 3378)
+++ config/locales/he.yml	(kopia robocza)
@@ -890,3 +890,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/fi.yml
===================================================================
--- config/locales/fi.yml	(wersja 3378)
+++ config/locales/fi.yml	(kopia robocza)
@@ -916,3 +916,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/bs.yml
===================================================================
--- config/locales/bs.yml	(wersja 3378)
+++ config/locales/bs.yml	(kopia robocza)
@@ -904,3 +904,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/fr.yml
===================================================================
--- config/locales/fr.yml	(wersja 3378)
+++ config/locales/fr.yml	(kopia robocza)
@@ -907,3 +907,4 @@
   enumeration_system_activity: Activité système
   label_board_sticky: Sticky
   label_board_locked: Locked
+  permission_manage_project_activities: Manage project activities
Index: config/locales/nl.yml
===================================================================
--- config/locales/nl.yml	(wersja 3378)
+++ config/locales/nl.yml	(kopia robocza)
@@ -868,3 +868,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/hr.yml
===================================================================
--- config/locales/hr.yml	(wersja 3378)
+++ config/locales/hr.yml	(kopia robocza)
@@ -893,3 +893,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/th.yml
===================================================================
--- config/locales/th.yml	(wersja 3378)
+++ config/locales/th.yml	(kopia robocza)
@@ -883,3 +883,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/pl.yml
===================================================================
--- config/locales/pl.yml	(wersja 3378)
+++ config/locales/pl.yml	(kopia robocza)
@@ -907,7 +907,8 @@
   version_status_locked: zablokowana
   version_status_open: otwarta
   
-  label_board_sticky: Sticky
-  label_board_locked: Locked
-  permission_export_wiki_pages: Export wiki pages
+  label_board_sticky: Przyklejona
+  label_board_locked: Zamknięta
+  permission_export_wiki_pages: Eksport stron wiki
+  permission_manage_project_activities: Zarządzanie aktywnościami projektu
   setting_cache_formatted_text: Cache formatted text
Index: config/locales/no.yml
===================================================================
--- config/locales/no.yml	(wersja 3378)
+++ config/locales/no.yml	(kopia robocza)
@@ -881,3 +881,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/hu.yml
===================================================================
--- config/locales/hu.yml	(wersja 3378)
+++ config/locales/hu.yml	(kopia robocza)
@@ -911,3 +911,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities
Index: config/locales/vi.yml
===================================================================
--- config/locales/vi.yml	(wersja 3378)
+++ config/locales/vi.yml	(kopia robocza)
@@ -945,3 +945,4 @@
   label_board_locked: Locked
   permission_export_wiki_pages: Export wiki pages
   setting_cache_formatted_text: Cache formatted text
+  permission_manage_project_activities: Manage project activities