--- de.yml_old	2010-02-19 10:04:21.000000000 +0100
+++ de.yml_new	2010-02-19 10:04:21.000000000 +0100
@@ -21,0 +22 @@
+        not_a_date: "is kein gültiges Datum"
@@ -29 +29,0 @@
-      models: 
@@ -32,3 +32 @@
-        header: 
-          one: "Konnte dieses {{model}} Objekt nicht speichern: 1 Fehler."
-          other: "Konnte dieses {{model}} Objekt nicht speichern: {{count}} Fehler."
+        header: "Dieses {{model}}-Objekt konnte nicht gespeichert werden: {{count}} Fehler."
@@ -48 +46 @@
-  button_copy_and_follow: Kopieren und beobachten
+  button_copy_and_follow: Kopieren und Ticket anzeigen
@@ -50 +48 @@
-  button_create_and_continue: Anlegen und weiter
+  button_create_and_continue: "Anlegen + nächstes Ticket"
@@ -53 +51 @@
-  button_duplicate: Duplikat
+  button_duplicate: Duplizieren
@@ -60 +58 @@
-  button_move_and_follow: Verschieben und beobachten
+  button_move_and_follow: Verschieben und Ticket anzeigen
@@ -112 +109,0 @@
-      only_day: "%e"
@@ -129,3 +126,3 @@
-    - :Tag
-    - :Monat
-    - :Jahr
+    - :day
+    - :month
+    - :year
@@ -139 +136 @@
-        other: etwa {{count}} Monate
+        other: etwa {{count}} Monaten
@@ -142 +139 @@
-        other: etwa {{count}} Jahre
+        other: etwa {{count}} Jahren
@@ -144,2 +141,2 @@
-        one: almost 1 year
-        other: almost {{count}} years
+        one: fast 1 Jahr
+        other: fast {{count}} Jahren
@@ -148 +145 @@
-        one: weniger als eine Minute
+        one: weniger als 1 Minute
@@ -150 +146,0 @@
-        zero: weniger als 1 Minute
@@ -154 +149,0 @@
-        zero: weniger als 1 Sekunde
@@ -157 +152 @@
-        other: mehr als {{count}} Jahre
+        other: mehr als {{count}} Jahren
@@ -160 +155 @@
-        other: "{{count}} Tage"
+        other: "{{count}} Tagen"
@@ -166 +161 @@
-        other: "{{count}} Monate"
+        other: "{{count}} Monaten"
@@ -194 +189 @@
-  enumeration_system_activity: "System Aktivität"
+  enumeration_system_activity: "System-Aktivität"
@@ -198 +193 @@
-  error_issue_done_ratios_not_updated: "Ticket-Fortschritt wurde nicht geändert."
+  error_issue_done_ratios_not_updated: Der Ticket-Fortschritt wurde nicht aktualisiert.
@@ -205,3 +200,3 @@
-  error_unable_delete_issue_status: Unable to delete issue status
-  error_workflow_copy_source: "Bitte wählen Sie einen Quell-Tracker oder eine Quell-Rolle."
-  error_workflow_copy_target: "Bitte wählen Sie Ziel-Tracker und Rolle(n)."
+  error_unable_delete_issue_status: "Der Ticket-Status konnte nicht gelöscht werden."
+  error_workflow_copy_source: "Bitte wählen Sie einen Quell-Tracker und eine Quell-Rolle."
+  error_workflow_copy_target: "Bitte wählen Sie die Ziel-Tracker und -Rollen."
@@ -247 +242 @@
-  field_identity_url: OpenID URL
+  field_identity_url: OpenID-URL
@@ -281 +276 @@
-  field_sharing: gemeinsam verwenden
+  field_sharing: Gemeinsame Verwendung
@@ -324 +319 @@
-  label_api_access_key_created_on: "Der API-Zugriffsschlüssel wurde vor {{value}} erstellt."
+  label_api_access_key_created_on: "Der API-Zugriffsschlüssel wurde vor {{value}} erstellt"
@@ -342 +337 @@
-  label_board_locked: Locked
+  label_board_locked: Gesperrt
@@ -345 +340 @@
-  label_board_sticky: Sticky
+  label_board_sticky: Wichtig (immer oben)
@@ -347 +342 @@
-  label_branch: Branch
+  label_branch: Zweig
@@ -371 +366 @@
-  label_copy_same_as_target: So wie Ziel
+  label_copy_same_as_target: So wie das Ziel
@@ -391 +386 @@
-  label_diff_inline: kombiniert
+  label_diff_inline: einspaltig
@@ -396 +391 @@
-  label_display_used_statuses_only: Zeige nur Status an, die von diesem Tracker verwendet werden.
+  label_display_used_statuses_only: Zeige nur Status an, die von diesem Tracker verwendet werden
@@ -476 +471 @@
-  label_login_with_open_id_option: oder Anmeldung mit OpenID
+  label_login_with_open_id_option: oder mit OpenID anmelden
@@ -594 +589 @@
-  label_tag: Tag
+  label_tag: Markierung
@@ -608 +603 @@
-  label_update_issue_done_ratios: Aktualisiere Ticketfortschritt
+  label_update_issue_done_ratios: Ticket-Fortschritt aktualisieren
@@ -626 +621 @@
-  label_version_sharing_none: Nicht geteilt
+  label_version_sharing_none: Nicht gemeinsam verwenden
@@ -629 +624 @@
-  label_view_all_revisions: Alle Revisionen anschauen.
+  label_view_all_revisions: Alle Revisionen anzeigen
@@ -642,4 +637 @@
-  label_x_closed_issues_abbr: 
-    one: 1 geschlossen
-    other: "{{count}} geschlossen"
-    zero: 0 geschlossen
+  label_x_closed_issues_abbr: "{{count}} geschlossen"
@@ -647 +639 @@
-    one: ein Kommentar
+    one: 1 Kommentar
@@ -649,9 +641,3 @@
-    zero: kein Kommentar
-  label_x_open_issues_abbr: 
-    one: 1 offen
-    other: "{{count}} offen"
-    zero: 0 offen
-  label_x_open_issues_abbr_on_total: 
-    one: 1 offen / {{total}}
-    other: "{{count}} offen / {{total}}"
-    zero: 0 offen / {{total}}
+    zero: keine Kommentare
+  label_x_open_issues_abbr: "{{count}} offen"
+  label_x_open_issues_abbr_on_total: "{{count}} offen / {{total}}"
@@ -677 +663 @@
-  mail_subject_wiki_content_updated: Die Wiki-Seite '{{page}}' wurde erfolgreich aktualisiert.
+  mail_subject_wiki_content_updated: Wiki-Seite '{{page}}' erfolgreich aktualisiert
@@ -679 +665 @@
-  notice_account_invalid_creditentials: "Benutzer oder Kennwort unzulässig"
+  notice_account_invalid_creditentials: "Benutzer oder Kennwort ist ungültig."
@@ -686 +672 @@
-  notice_account_wrong_password: Falsches Kennwort
+  notice_account_wrong_password: Falsches Kennwort.
@@ -695 +681 @@
-  notice_issue_done_ratios_updated: Ticketfortschritt aktualisiert.
+  notice_issue_done_ratios_updated: Der Ticket-Fortschritt wurde aktualisiert.
@@ -703 +689 @@
-  notice_unable_delete_version: "Die Version konnte nicht gelöscht werden"
+  notice_unable_delete_version: "Die Version konnte nicht gelöscht werden."
@@ -708 +694 @@
-        format: "%n%u"
+        format: "%n %u"
@@ -742,2 +728,2 @@
-  permission_add_project: Projekt erstellen.
-  permission_add_subprojects: Unterprojekte erstellen.
+  permission_add_project: Projekt erstellen
+  permission_add_subprojects: Unterprojekte erstellen
@@ -762 +748 @@
-  permission_export_wiki_pages: Export wiki pages
+  permission_export_wiki_pages: Wiki-Seiten exportieren
@@ -771 +757 @@
-  permission_manage_project_activities: Manage project activities
+  permission_manage_project_activities: "Aktivitäten (Zeiterfassung) verwalten"
@@ -807 +793 @@
-  setting_cache_formatted_text: Cache formatted text
+  setting_cache_formatted_text: Formatierten Text im Cache speichern
@@ -821,3 +807,3 @@
-  setting_file_max_size_displayed: "Maximale Größe der abgezeigten Textdatei"
-  setting_gravatar_default: Standard Gravatar-Bild
-  setting_gravatar_enabled: Gravatar Benutzerbilder benutzen
+  setting_file_max_size_displayed: "Maximale Größe inline angezeigter Textdateien"
+  setting_gravatar_default: Standard-Gravatar-Bild
+  setting_gravatar_enabled: Gravatar-Benutzerbilder benutzen
@@ -825,3 +811,3 @@
-  setting_issue_done_ratio: Berechne den Ticket-Fortschritt durch
-  setting_issue_done_ratio_issue_field: Benutze das Ticket-Feld.
-  setting_issue_done_ratio_issue_status: Verwende den Ticketstatus.
+  setting_issue_done_ratio: Berechne den Ticket-Fortschritt mittels
+  setting_issue_done_ratio_issue_field: Ticket-Feld %-erledigt
+  setting_issue_done_ratio_issue_status: Ticket-Status
@@ -834,4 +820,4 @@
-  setting_mail_handler_body_delimiters: Schneide E-Mails nach einer der folgenden Zeile ab.
-  setting_new_project_user_role_id: Die Rolle ist einem Nicht-Administrator zugeordnet, der ein Projekt erstellt.
-  setting_openid: Erlaube OpenID Anmeldung und Registrierung
-  setting_password_min_length: "Mindestlänge des Passworts"
+  setting_mail_handler_body_delimiters: Schneide E-Mails nach einer dieser Zeilen ab
+  setting_new_project_user_role_id: Rolle, die einem Nicht-Administrator zugeordnet wird, der ein Projekt erstellt
+  setting_openid: Erlaube OpenID-Anmeldung und -Registrierung
+  setting_password_min_length: "Mindestlänge des Kennworts"
@@ -842,2 +828,2 @@
-  setting_repository_log_display_limit: Maximale Anzahl angezeigter Revisionen des Datei Logs
-  setting_rest_api_enabled: REST Schnittstelle aktivieren.
+  setting_repository_log_display_limit: Maximale Anzahl anzuzeigender Revisionen in der Historie einer Datei
+  setting_rest_api_enabled: REST-Schnittstelle aktivieren
@@ -873 +859 @@
-  text_enumeration_destroy_question: "{{count}} Objekte sind diesem Wert zugeordnet."
+  text_enumeration_destroy_question: "{{count}} Objekt(e) sind diesem Wert zugeordnet."
@@ -882,4 +868,4 @@
-  text_journal_added: "{{label}} {{value}} hinzugefügt"
-  text_journal_changed: "{{label}} wurde geändert von {{old}} zu {{new}}."
-  text_journal_deleted: "{{label}} wurde gelöscht (Wert: {{old}})."
-  text_journal_set_to: "{{label}} wurde gesetzt auf {{value}}."
+  text_journal_added: "{{label}} {{value}} wurde hinzugefügt"
+  text_journal_changed: "{{label}} wurde von {{old}} zu {{new}} geändert"
+  text_journal_deleted: "{{label}} {{old}} wurde gelöscht"
+  text_journal_set_to: "{{label}} wurde auf {{value}} gesetzt"
@@ -892,2 +878,2 @@
-  text_own_membership_delete_confirmation: "Sie sind dabei, einige oder alle ihre Berechtigungen zu entfernen. Es ist möglich, dass Sie danach das Projekt nicht mehr sehen oder editieren dürfen. \n\
-    Sind Sie wirklich sicher, dass Sie dies tun möchten?"
+  text_own_membership_delete_confirmation: "Sie sind dabei, einige oder alle Ihre Berechtigungen zu entfernen. Es ist möglich, dass Sie danach das Projekt nicht mehr ansehen oder bearbeiten dürfen.\n\
+    Sind Sie sicher, dass Sie dies tun möchten?"
@@ -916,3 +902,3 @@
-  text_wiki_page_destroy_question: Diese Seite hat {{descendants}} Unterseite(n). Sind Sie sicher?
-  text_wiki_page_nullify_children: Behalte Unterseite als Hauptseite
-  text_wiki_page_reassign_children: Ordne Unterseite dieser Seite zu
+  text_wiki_page_destroy_question: "Diese Seite hat {{descendants}} Unterseite(n). Was möchten Sie tun?"
+  text_wiki_page_nullify_children: Verschiebe die Unterseiten auf die oberste Ebene
+  text_wiki_page_reassign_children: Ordne die Unterseiten dieser Seite zu
@@ -923 +909 @@
-      default: "%a, %d.%m.%Y, %H:%M Uhr"
+      default: "%d.%m.%Y %H:%M"
@@ -925 +911 @@
-      short: "%e. %B, %H:%M Uhr"
+      short: "%e. %b %H:%M"
@@ -928 +914 @@
-  version_status_closed: geschlossen
+  version_status_closed: abgeschlossen
@@ -931 +917,3 @@
-  warning_attachments_not_saved: "{{count}} Datei(en) konnten nicht gespeichert werden."
+  warning_attachments_not_saved: 
+    one: 1 Datei konnte nicht gespeichert werden.
+    other: "{{count}} Dateien konnten nicht gespeichert werden."