Index: config/locales/no.yml
===================================================================
--- config/locales/no.yml (revision 3733)
+++ config/locales/no.yml (working copy)
@@ -55,8 +55,8 @@
         one: "over 1 år"
         other: "over {{count}} år"
       almost_x_years:
-        one:   "almost 1 year"
-        other: "almost {{count}} years"
+        one:   "nesten 1 år"
+        other: "nesten {{count}} år"
   number:
     format:
       precision: 2
@@ -302,9 +302,9 @@
   label_project_new: Nytt prosjekt
   label_project_plural: Prosjekter
   label_x_projects:
-    zero:  no projects
-    one:   1 project
-    other: "{{count}} projects"
+    zero:  ingen prosjekter
+    one:   1 prosjekt
+    other: "{{count}} prosjekter"
   label_project_all: Alle prosjekter
   label_project_latest: Siste prosjekter
   label_issue: Sak
@@ -410,18 +410,18 @@
   label_closed_issues: lukket
   label_closed_issues_plural: lukkede
   label_x_open_issues_abbr_on_total:
-    zero:  0 open / {{total}}
-    one:   1 open / {{total}}
-    other: "{{count}} open / {{total}}"
+    zero:  0 åpne / {{total}}
+    one:   1 åpen / {{total}}
+    other: "{{count}} åpne / {{total}}"
   label_x_open_issues_abbr:
-    zero:  0 open
-    one:   1 open
-    other: "{{count}} open"
+    zero:  0 åpne
+    one:   1 åpen
+    other: "{{count}} åpne"
   label_x_closed_issues_abbr:
-    zero:  0 closed
-    one:   1 closed
-    other: "{{count}} closed"
-  label_total: Total
+    zero:  0 lukka
+    one:   1 lukka
+    other: "{{count}} lukka"
+  label_total: Totalt
   label_permissions: Godkjenninger
   label_current_status: Nåværende status
   label_new_statuses_allowed: Tillatte nye statuser
@@ -444,9 +444,9 @@
   label_comment: Kommentar
   label_comment_plural: Kommentarer
   label_x_comments:
-    zero: no comments
-    one: 1 comment
-    other: "{{count}} comments"
+    zero: no kommentarer
+    one: 1 kommentar
+    other: "{{count}} kommentarer"
   label_comment_add: Legg til kommentar
   label_comment_added: Kommentar lagt til
   label_comment_delete: Slett kommentar
@@ -709,70 +709,70 @@
   enumeration_issue_priorities: Sakssprioriteringer
   enumeration_doc_categories: Dokument-kategorier
   enumeration_activities: Aktiviteter (tidssporing)
-  text_enumeration_category_reassign_to: 'Reassign them to this value:'
-  text_enumeration_destroy_question: "{{count}} objects are assigned to this value."
-  label_incoming_emails: Incoming emails
-  label_generate_key: Generate a key
-  setting_mail_handler_api_enabled: Enable WS for incoming emails
-  setting_mail_handler_api_key: API key
-  text_email_delivery_not_configured: "Email delivery is not configured, and notifications are disabled.\nConfigure your SMTP server in config/email.yml and restart the application to enable them."
-  field_parent_title: Parent page
-  label_issue_watchers: Watchers
-  setting_commit_logs_encoding: Commit messages encoding
-  button_quote: Quote
-  setting_sequential_project_identifiers: Generate sequential project identifiers
-  notice_unable_delete_version: Unable to delete version
-  label_renamed: renamed
-  label_copied: copied
-  setting_plain_text_mail: plain text only (no HTML)
-  permission_view_files: View files
-  permission_edit_issues: Edit issues
-  permission_edit_own_time_entries: Edit own time logs
-  permission_manage_public_queries: Manage public queries
-  permission_add_issues: Add issues
-  permission_log_time: Log spent time
-  permission_view_changesets: View changesets
-  permission_view_time_entries: View spent time
-  permission_manage_versions: Manage versions
-  permission_manage_wiki: Manage wiki
-  permission_manage_categories: Manage issue categories
-  permission_protect_wiki_pages: Protect wiki pages
-  permission_comment_news: Comment news
-  permission_delete_messages: Delete messages
-  permission_select_project_modules: Select project modules
-  permission_manage_documents: Manage documents
-  permission_edit_wiki_pages: Edit wiki pages
-  permission_add_issue_watchers: Add watchers
-  permission_view_gantt: View gantt chart
-  permission_move_issues: Move issues
-  permission_manage_issue_relations: Manage issue relations
-  permission_delete_wiki_pages: Delete wiki pages
-  permission_manage_boards: Manage boards
-  permission_delete_wiki_pages_attachments: Delete attachments
-  permission_view_wiki_edits: View wiki history
-  permission_add_messages: Post messages
-  permission_view_messages: View messages
-  permission_manage_files: Manage files
-  permission_edit_issue_notes: Edit notes
-  permission_manage_news: Manage news
-  permission_view_calendar: View calendrier
-  permission_manage_members: Manage members
-  permission_edit_messages: Edit messages
-  permission_delete_issues: Delete issues
-  permission_view_issue_watchers: View watchers list
-  permission_manage_repository: Manage repository
-  permission_commit_access: Commit access
-  permission_browse_repository: Browse repository
-  permission_view_documents: View documents
-  permission_edit_project: Edit project
-  permission_add_issue_notes: Add notes
-  permission_save_queries: Save queries
-  permission_view_wiki_pages: View wiki
-  permission_rename_wiki_pages: Rename wiki pages
-  permission_edit_time_entries: Edit time logs
-  permission_edit_own_issue_notes: Edit own notes
-  setting_gravatar_enabled: Use Gravatar user icons
-  label_example: Example
+  text_enumeration_category_reassign_to: 'Endre dem til denne verdien:'
+  text_enumeration_destroy_question: "{{count}} objekter er endret til denne verdien."
+  label_incoming_emails: Innkommende e-post
+  label_generate_key: Generer en nøkkel
+  setting_mail_handler_api_enabled: Skru på WS for innkommende e-post
+  setting_mail_handler_api_key: API-nøkkel
+  text_email_delivery_not_configured: "Levering av e-post er ikke satt opp, og varsler er skrudd av.\nStill inn din SMTP-tjener i config/email.yml og start programmet på nytt for å skru det på."
+  field_parent_title: Foreldreside
+  label_issue_watchers: Overvåkere
+  setting_commit_logs_encoding: Tegnkoding for innsendingsmeldinger
+  button_quote: Sitat
+  setting_sequential_project_identifiers: Generer sekvensielle prosjekt-IDer
+  notice_unable_delete_version: Kan ikke slette versjonen
+  label_renamed: gitt nytt navn
+  label_copied: kopiert
+  setting_plain_text_mail: kun ren tekst (ikke HTML)
+  permission_view_files: Vise filer
+  permission_edit_issues: Redigere saker
+  permission_edit_own_time_entries: Redigere egne timelister
+  permission_manage_public_queries: Behandle delte søk
+  permission_add_issues: Legge inn saker
+  permission_log_time: Loggføre timer
+  permission_view_changesets: Vise endringssett
+  permission_view_time_entries: Vise brukte timer
+  permission_manage_versions: Behandle versjoner
+  permission_manage_wiki: Behandle wiki
+  permission_manage_categories: Behandle kategorier for saker
+  permission_protect_wiki_pages: Beskytte wiki-sider
+  permission_comment_news: Kommentere nyheter
+  permission_delete_messages: Slette meldinger
+  permission_select_project_modules: Velge prosjekt-moduler
+  permission_manage_documents: Behandle dokumenter
+  permission_edit_wiki_pages: Redigere wiki-sider
+  permission_add_issue_watchers: Legge til overvåkere
+  permission_view_gantt: Vise gantt-diagram
+  permission_move_issues: Flytte saker
+  permission_manage_issue_relations: Behandle saksrelasjoner
+  permission_delete_wiki_pages: Slette wiki-sider
+  permission_manage_boards: Behandle forum
+  permission_delete_wiki_pages_attachments: Slette vedlegg
+  permission_view_wiki_edits: Vise wiki-historie
+  permission_add_messages: Sende meldinger
+  permission_view_messages: Vise meldinger
+  permission_manage_files: Behandle filer
+  permission_edit_issue_notes: Redigere notater
+  permission_manage_news: Behandle nyheter
+  permission_view_calendar: Vise kalender
+  permission_manage_members: Behandle medlemmer
+  permission_edit_messages: Redigere meldinger
+  permission_delete_issues: Slette saker
+  permission_view_issue_watchers: Vise liste over overvåkere
+  permission_manage_repository: Behandle depot
+  permission_commit_access: Tilgang til innsending
+  permission_browse_repository: Bla gjennom depot
+  permission_view_documents: Vise dokumenter
+  permission_edit_project: Redigere prosjekt
+  permission_add_issue_notes: Legge til notater
+  permission_save_queries: Lagre søk
+  permission_view_wiki_pages: Vise wiki
+  permission_rename_wiki_pages: Gi wiki-sider nytt navn
+  permission_edit_time_entries: Redigere timelister
+  permission_edit_own_issue_notes: Redigere egne notater
+  setting_gravatar_enabled: Bruk Gravatar-brukerikoner
+  label_example: Eksempel
   text_repository_usernames_mapping: "Select ou update the Redmine user mapped to each username found in the repository log.\nUsers with the same Redmine and repository username or email are automatically mapped."
   permission_edit_own_messages: Edit own messages
   permission_delete_own_messages: Delete own messages